/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: chi.yu $
 * $Date: 2015/07/20 $
 * $RCSfile: dmx_pcr_hal.h,v $
 * $Revision: #2 $
 *
 *---------------------------------------------------------------------------*/

/** @file dmx_pcr_hal.h
 *  This header file of dmx pcr hal 
 */


#ifndef _DMX_PCR_HAL_H_
#define _DMX_PCR_HAL_H_
#include "x_typedef.h"
#include "x_debug.h"

//return value
#define STC_HAL_OK                     (0)
#define STC_HAL_FAIL                   (1)
#define STC_HAL_INV_ARG                (2)
#define STC_HAL_INTERNAL_ERR           (3)
#define STC_HAL_NOT_IMPL               (4)

#define STC_HAL_TRACE(fmt...)          LOG(11, fmt)
#define STC_MK_RET(ret)                ((__LINE__<<8)|(ret))     
#define STC_RET(ret)                   ((ret)&0x000000FF)     
#define STC_MK_REALD_DATA(tag,offset)  (((tag)<<16)|(offset))

#define STC_NULL_HANDLE                ((void *)0)
typedef VOID * STC_HANDLE_T;

typedef enum
{
    STC_HAL_ISR_CLR,
    STC_HAL_SET_STC,
    STC_HAL_ERR_CLR,
    STC_HAL_NERR_CLR,
    STC_HAL_TYPE_MAX
} STC_HAL_TYPE_T;

typedef enum
{
    STC_HAL_STATUS,
    STC_HAL_PCR_DIFF,
    STC_HAL_GET_STC,
    STC_HAL_GET_PCR,
    STC_HAL_GET_SNAP_STC,
    STC_HAL_GET_STCEXT,
    STC_HAL_GTYPE_MAX
} STC_HAL_GET_TYPE_T;

typedef enum
{
    DMX_PCR_HAL_ISTYPE_MAX
} DMX_PCR_HAL_IS_TYPE_T;

typedef struct _STC_HAL_OBJECT_T
{
    //common
    UINT8   u1Id;
    UINT8   u1Used;
    UINT8   u1Status;
    BOOL    fgDmxStc;
    BOOL    fgEnable;
    VOID*   pvHost;
   
    //function
    UINT32      (*Reset)     (struct _STC_HAL_OBJECT_T *);
    UINT32      (*Enable)    (struct _STC_HAL_OBJECT_T *);
    UINT32      (*Disable)   (struct _STC_HAL_OBJECT_T *);
    UINT32      (*Set)       (struct _STC_HAL_OBJECT_T *, STC_HAL_TYPE_T, VOID *);
    UINT32      (*Get)       (struct _STC_HAL_OBJECT_T *, STC_HAL_GET_TYPE_T, VOID *);
    UINT32      (*Is)        (struct _STC_HAL_OBJECT_T *, DMX_PCR_HAL_IS_TYPE_T, VOID *);

    UINT8 begin;
    //local 
    UCHAR ucDmxPcrId;

    UINT8 end;
}STC_HAL_OBJECT_T;

typedef struct 
{
    UINT8 u1Data;
    VOID * pvData;
} STC_OBJCfG_T;

typedef struct 
{
    UINT32 u4NoErrFst;
    UINT32 u4NoErrSnd;
} STC_HAL_STATUS_T;

typedef struct 
{
    UINT32 u4Lowbits;
    UINT32 u4Highbits;
} STC_HAL_PCR_DIFF_T;

typedef union _DMX_DELTA_UNION_T
{
    INT64 i8Delta;
    UINT32 au4Delta[2];
} DMX_DELTA_UNION_T;

//-----------------------------------------------------------------------------
// Prototype  of public functions
//-----------------------------------------------------------------------------

VOID STC_HAL_Init(VOID);
STC_HANDLE_T STC_HAL_Open(VOID* pvArg);
UINT32 STC_HAL_Enable(STC_HANDLE_T hStc);
UINT32 STC_HAL_Disable(STC_HANDLE_T hStc);
UINT32 STC_HAL_Set(STC_HANDLE_T hStc, STC_HAL_TYPE_T eType, VOID *pvArg);
UINT32 STC_HAL_Get(STC_HANDLE_T hStc, STC_HAL_GET_TYPE_T eType, VOID *pvArg);
UINT32 STC_HAL_Reset(STC_HANDLE_T hStc);
STC_HAL_OBJECT_T * STC_HW_Get_Object(UINT8 u1Idx);


#endif /*_DMX_PCR_HAL_H_*/

