/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: chi.yu $
 * $Date: 2015/06/11 $
 * $RCSfile: dmx_pcr_reg.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

/** @file dmx_pcr_reg.h
 *  This header file declares register map of dmx pcr.
 */


#ifndef _DMX_PCR_REG_H_
#define _DMX_PCR_REG_H_

/*
hd and sd share the register defines from 0 to 0x60
*/

#define DMX_HD_BASE 0x0
#define DMX_SD_BASE 0x50

#define DMX_PCRCR (0x208)
    #define PWM_FORMAT Fld(4,28,AC_MSKB3)//[31:28]
    #define PWM_BITS Fld(4,24,AC_MSKB3)//[27:24]
    #define PWM_SHIFT Fld(8,16,AC_FULLB2)//[23:16]
    #define YN_SHIFT Fld(8,8,AC_FULLB1)//[15:8]
    #define PP_INT_EN Fld(1,3,AC_MSKB0)//[3:3]
    #define PC_INTDIS Fld(1,2,AC_MSKB0)//[2:2]
    #define NEW_PCR Fld(1,1,AC_MSKB0)//[1:1]
    #define AUTO_LD Fld(1,0,AC_MSKB0)//[0:0]
#define DMX_PCRETR (0x20c)
#define DMX_PCRFCR1 (0x210)
#define DMX_PCRFCR2 (0x214)
#define DMX_PCRFCR3 (0x218)
#define DMX_PCRFCR4 (0x21c)
#define DMX_PCRBSER (0x220)
    #define PCR_BSH Fld(1,31,AC_MSKB3)//[31:31]
    #define PCR_EXT Fld(8,0,AC_FULLB0)//[7:0]
#define DMX_PCRBSR (0x224)
#define DMX_STCBSER (0x228)
    #define STC_BSH Fld(1,31,AC_MSKB3)//[31:31]
    #define STC_EXT Fld(8,0,AC_FULLB0)//[7:0]
#define DMX_STCBSR (0x22c)
#define DMX_PMSER1 (0x230)
#define DMX_PMSER2 (0x234)
#define DMX_SSTCR1 (0x238)
#define DMX_SSTCR2 (0x23c)
#define DMX_PCRXN1R (0x240)
#define DMX_PCRYN1R (0x244)
#define DMX_PCRYN2R (0x248)
#define DMX_PCRESR (0x2d0)
#define DMX_PCRNER1 (0x2d4)
#define DMX_PCRNER2 (0x2d8)
#define DMX_PCR1ESR (0x2f8)
#define DMX_PCR1NER1 (0x2fc)
#define DMX_PCR1NER2 (0x300)

#define PARSER_HD_BASE 0x0
#define PARSER_SD_BASE 0x69000

#define AUD_STCA (0x1c4)
#define AUD_STCCTL (0x1f4)
    #define HDSPW Fld(1,3,AC_MSKB0)//[3:3]
    #define HSTCA Fld(1,1,AC_MSKB0)//[1:1]
    #define HSTC Fld(1,0,AC_MSKB0)//[0:0]
#endif /*_DMX_PCR_REG_H_*/