/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author$
 * $Date$
 * $RCSfile: $
 * $Revision$
 *
 *---------------------------------------------------------------------------*/

/** @file gcpu_iram.h
 *  gcpu driver - instruction ram uCode inclusion
 */

static const unsigned int GCPU_IRAM0_TRAPPING[] = {
0x82050207,     // bypass AES security check, this trapping should always in array last item index
0x821b201f,     // for aes cbc iv reload function, set register for iv reload
0x821c2022,     // for aes cbc iv reload function, judge iv len ans reload IV
0x825e2032,     // for aes cbc iv reload function, update final iv
0x840e204a,     // for setting AACS_DBD/EBD/DTN/ETN IV 
};

static const unsigned int GCPU_IRAM0_CODE[] = {
0x001d8955, 0x001c8be8, 0x000909fa, 0x001ee975, 0x001de946, 
0x00128b35, 0x001ee914, 0x001ee927, 0x001bc147, 0x000809fa, 
0x000c0957, 0x000880a9, 0x001b8975, 0x001b8dd4, 0x001ac167, 
0x000fa95f, 0x000909fa, 0x001ee974, 0x001ee915, 0x001de946, 
0x00128b35, 0x001ee927, 0x001bc147, 0x000809fa, 0x00088359, 
0x000c0115, 0x001b8975, 0x001b8dd4, 0x001ac167, 0x000fa94d, 
0x000909fa, 0x001ee92b, 0x001991d3, 0x00090b49, 0x001aa575, 
0x000f8b76, 0x001ee921, 0x001ee8e0, 0x0011dbf5, 0x000f297a, 
0x001bdd53, 0x001991d3, 0x001de985, 0x001dc804, 0x001d89c7, 
0x0008898d, 0x00090b7e, 0x001bd953, 0x001991d3, 0x0009297f, 
0x001d8975, 0x0010a555, 0x00080b30, 0x0011dbf5, 0x000f2910, 
0x0011f3eb, 0x000f2910, 0x001bf14b, 0x00082910, 0x0011f3f5, 
0x000f296b, 0x00090b49, 0x001bf153, 0x001991d3, 0x001de985, 
0x001dc804, 0x001d89c7, 0x0008898d, 0x00090b7e, 0x001dc805, 
0x001de9a4, 0x001d89c7, 0x000889b4, 0x00090b30, 0x001de865, 
0x001dc804, 0x001d89c7, 0x0008898d, 0x00090aa5
};

#define GCPU_IRAM0_LEN   0x13C

