/******************************************************************************
*
* This file is provided under a dual license.  When you use or
* distribute this software, you may choose to be licensed under
* version 2 of the GNU General Public License ("GPLv2 License")
* or BSD License.
*
* GPLv2 License
*
* Copyright(C) 2016 MediaTek Inc.
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of version 2 of the GNU General Public License as
* published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful, but
* WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See http://www.gnu.org/licenses/gpl-2.0.html for more details.
*
* BSD LICENSE
*
* Copyright(C) 2016 MediaTek Inc. All rights reserved.
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions
* are met:
*
*  * Redistributions of source code must retain the above copyright
*    notice, this list of conditions and the following disclaimer.
*  * Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in
*    the documentation and/or other materials provided with the
*    distribution.
*  * Neither the name of the copyright holder nor the names of its
*    contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
* "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
* A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
* HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
* SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
* LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
* THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
* OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*****************************************************************************/
/*-----------------------------------------------------------------------------
  * $RCSfile: modelIndex_cust.c,v $
  * $Revision: #3 $
  * $Date: 2014/10/31 $
  * $Author: weibo.li $
  * Description:
  *
  *---------------------------------------------------------------------------*/
#ifdef CC_ENABLE_MTK_MODEL_INDEX

#ifndef MODEL_INDEX_H
#define MODEL_INDEX_H

#ifdef CUSTOM_MODEL_INDEX
#include CUSTOM_MODEL_INDEX
#else
#include "./Vizio/modelIndexCustom.h"
#endif

// 16:9 W=2.2138Xsize  V=1.2453Xsize
#define MAKE_ACTIVE_AREA(h, v)   (((h)<<16) | ((v)&(0xFFFF)))

typedef struct _MAIN_MODELINDEX_DATA_T
{
    // CC_ENABLE_MODEL_INDEX
    // Driver part: don't modify!!!
    UINT32  u4PanelId;
    UINT32  u4TunerId;
    UINT32  u4FbmId;
    UINT32  u4MirrorFlipOpt;
    char*   s_MODEL_NAME;
    char*   s_MODEL_STATUS;
    UINT8   iOSD_Information;
    UINT32  u4AQId;
    UINT32  u4PQId;    
    UINT32  u4EdidId;
    UINT32  u4PanelActiveArea;
    UINT8	i3D_Model_Information;
    BOOL    u1HDMIInverse;

    // Extention part
    struct_exter_model_Index	external_data;
}   MAIN_MODELINDEX_DATA_T;

typedef enum
{
    oVIA    = (UINT8)0x01,
    oPIP    = (UINT8)0x02,
    oBT     = (UINT8)0x04,
    o3D     = (UINT8)0x08,
}OSD_Information;
extern UINT32 GetCurrentModelIndex_Vizio(VOID);
extern BOOL GetLIGHTSENSORSupport(VOID);
BOOL IsLocalDimmingEnable(VOID);

extern void SetCurrentOdmId(UINT32 final_index);

extern void SetCurrentOdmModelIndex(UINT32 final_index);

extern char *GetCurrentModelIndexOdmName(void);

extern UINT32 GetCurrentOdmId(void);

extern UINT32 GetCurrentOdmModelIndex(void);

extern UINT16 GetModelIndexTableSize(void);

extern void * GetModelIndexTable(UINT32 index);

extern UINT8 GetModelIndexCount(void);

#if !defined(CC_UBOOT) && !defined(CC_MTK_LOADER) && !defined(CC_MTK_PRELOADER)
extern UINT8 GetModelIndexID(void);
#endif

extern UINT32 GetModelIndexPanelId(UINT32 index);

extern UINT32 GetModelIndexTunerId(UINT32 index);

extern UINT32 GetModelIndexFbmId(UINT32 index);

extern UINT32 GetModelIndexMirrorFlipOpt(UINT32 index);

extern UINT32 GetModelIndexAQId(UINT32 index);

extern UINT32 GetModelIndexPQId(UINT32 index);

extern UINT32 GetModelIndexEdidId(UINT32 index);

extern UINT32 GetModelIndexPanelActiveArea(UINT32 index);

extern UINT32 GetModelIndex3DModelInformation(UINT32 index);

extern BOOL GetModelIndexHDMIInversePort(UINT32 index);

extern BOOL GetModelIndexFBMType(UINT32 index);
/*----------------------------------------------------------------------------
   Description : This function returns model name with current model index
   Parameter1 : None
   Return    : model name in mode index table
 ---------------------------------------------------------------------------*/
     
extern CHAR* GetModelName(VOID);

extern CHAR* GetModelStatus(VOID);

extern UINT32 GetModelIndexOSDFormal( VOID);

#endif // MODEL_INDEX_H
#endif // CC_ENABLE_MTK_MODEL_INDEX
