/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date  $
 * $RCSfile: drv_dram.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

#ifndef _DRV_DRAM_H_
#define _DRV_DRAM_H_

#include "typedef.h"
#include "dram_map.h"


/*****************************************************************************
  Function Declaration
  ***************************************************************************/
extern void vDramInit(void) ;

extern UINT8 bReadDramB(UPTR dwAddr)   ;
extern UINT16 wReadDramW(UPTR dwAddr)   ;
extern UINT32 dwReadDramD(UPTR dwAddr)   ;

extern void vWriteDramB(UPTR dwAddr, UINT8 bData)   ;
extern void vWriteDramW(UPTR dwAddr, UINT16 wData)   ;
extern void vWriteDramD(UPTR dwAddr, UINT32 dwData)   ;

// for Big Endian Function
extern UINT16 wReadDramW_B(UPTR dwAddr)   ;
extern UINT32 dwReadDramD_B(UPTR dwAddr)   ;
extern void vWriteDramW_B(UPTR dwAddr, UINT16 wData)   ;
extern void vWriteDramD_B(UPTR dwAddr, UINT32 dwData)   ;

extern void vDmaDram2Sram(UINT32 dwSrc, void   * pDst, UINT16 wLen) ;
extern void vDmaDram2SramAligned(UINT32 dwSrc, void   *pDst, UINT16 wLen) ;
extern void vDmaSram2Dram(void   * pSrc, UINT32 dwDst, UINT16 wLen) ;
extern void vDmaSram2DramAligned(void   *pSrc, UINT32 dwDst, UINT16 wLen) ;

extern void vDmaFlash2Dram(UINT32 dwSrc, UINT32 dwDest, UINT16 wLen) ;

extern UINT8 bReadFlash(UINT32 dwAddr) ;
extern UINT16 wReadFlash(UINT32 dwAddr) ;
extern UINT32 dwReadFlash(UINT32 dwAddr) ;
extern void vGDDR3OnlineCal(void);

extern UINT32 u4GDDR3OnlineCal;	//0:disable 1:on-line cal wo log 2. on-line cal with log
extern UINT32 u4OnlineCalTime;	//cal per 1sec
extern INT32 u4GDDR3ODTP,u4GDDR3DRVP_tmp, u4GDDR3DRVN, u4GDDR3DRVP;
extern void vGDDR3Cal(void);

/*****************************************************************************
  Variable Declaration
  ***************************************************************************/
#endif
