/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @file c_hbbtv.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *  
 *  @par Description: This header file declares HBBTV exported APIs.
 */
/*----------------------------------------------------------------------------*/
#ifndef _U_OPERA_HBBTV_SI_LOADER_H_
#define _U_OPERA_HBBTV_SI_LOADER_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"
#include "u_handle.h"
#include "u_opera_hbbtv.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/

#define OPHT_SI_LOADER            (HT_GROUP_OP_HBBTV + (HANDLE_TYPE_T) 0)

typedef UINT16 OPERA_HBBTV_SIL_NFY_COND_T;

#define OPERA_HBBTV_SIL_COND_LOAD_START      ((OPERA_HBBTV_SIL_NFY_COND_T)  0)
#define OPERA_HBBTV_SIL_COND_LOAD_RUNNING    ((OPERA_HBBTV_SIL_NFY_COND_T)  1)
#define OPERA_HBBTV_SIL_COND_LOAD_FAILED     ((OPERA_HBBTV_SIL_NFY_COND_T)  2)

typedef UINT16 OPERA_HBBTV_SIL_NFY_DATA_T;

#define OPERA_HBBTV_SIL_PAT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  1)
#define OPERA_HBBTV_SIL_PAT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  2)
#define OPERA_HBBTV_SIL_PAT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  3)
#define OPERA_HBBTV_SIL_PAT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  4)
#define OPERA_HBBTV_SIL_PMT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  5) /*PMT available*/
#define OPERA_HBBTV_SIL_PMT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  6)
#define OPERA_HBBTV_SIL_PMT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  7)
#define OPERA_HBBTV_SIL_PMT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  8)
#define OPERA_HBBTV_SIL_AIT_UPDATE      ((OPERA_HBBTV_SIL_NFY_DATA_T)  9) /*App available, to enable HbbTV engine*/
#define OPERA_HBBTV_SIL_AIT_CHANGED     ((OPERA_HBBTV_SIL_NFY_DATA_T)  10)
#define OPERA_HBBTV_SIL_AIT_UNAVAIL     ((OPERA_HBBTV_SIL_NFY_DATA_T)  11)
#define OPERA_HBBTV_SIL_AIT_TIMEOUT     ((OPERA_HBBTV_SIL_NFY_DATA_T)  12)
#define OPERA_HBBTV_SIL_AIT_LOAD_FAIL   ((OPERA_HBBTV_SIL_NFY_DATA_T)  13)
#define OPERA_HBBTV_SIL_ROOT_TIMEOUT    ((OPERA_HBBTV_SIL_NFY_DATA_T)  14)
#define OPERA_HBBTV_SIL_UNLOADED        ((OPERA_HBBTV_SIL_NFY_DATA_T)  15)
#define OPERA_HBBTV_SIL_NOT_ALLOWED     ((OPERA_HBBTV_SIL_NFY_DATA_T)  16)

typedef enum{
    OPERA_HBBTV_SIL_GET_UNKNOWN,
    OPERA_HBBTV_SIL_GET_AIT_LENGTH,
    OPERA_HBBTV_SIL_GET_AIT_SECTION,
    OPERA_HBBTV_SIL_GET_PMT_LENGTH,
    OPERA_HBBTV_SIL_GET_PMT_SECTION,    
    OPERA_HBBTV_SIL_GET_BRDCST_MEDIUM
}OPERA_HBBTV_SIL_GET_TYPE;

typedef VOID (*x_opera_hbbtv_sil_nfy_fct)(
                    OPERA_HBBTV_SIL_NFY_COND_T  e_nfy_cond,
                    VOID*                       pv_data,
                    VOID*                       pv_nfy_tag);


#endif



