/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @file c_hbbtv.h
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *
 *  @par Description: This header file declares HBBTV exported APIs.
 */
/*----------------------------------------------------------------------------*/
#ifndef _X_OPERA_HBBTV_H_
#define _X_OPERA_HBBTV_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"
#include "u_handle.h"
#include "u_gl.h"

#include "u_opera_hbbtv.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/
#define HBBTV_KEY_STATE_DOWN          ((UINT32) 0)        /* key down state */
#define HBBTV_KEY_STATE_UP            ((UINT32) 1)        /* key up state   */
#define HBBTV_KEY_STATE_REPEAT        ((UINT32) 2)        /* key repeat     */

typedef INT32   OPERA_HBBTV_BWS_MSG_TYPE_T;
#define OPERA_HBBTV_BWS_MSG_UNKNOWN          ((OPERA_HBBTV_BWS_MSG_TYPE_T)  0)
#define OPERA_HBBTV_BWS_MSG_IS_HBBTV_TYPE    ((OPERA_HBBTV_BWS_MSG_TYPE_T)  1)
#define OPERA_HBBTV_BWS_MSG_EXIT_HBBTV_TYPE  ((OPERA_HBBTV_BWS_MSG_TYPE_T)  2)
#define OPERA_HBBTV_BWS_MSG_LANG_CHG         ((OPERA_HBBTV_BWS_MSG_TYPE_T)  3)
#define OPERA_HBBTV_BWS_MSG_CLEAR_COOKIE     ((OPERA_HBBTV_BWS_MSG_TYPE_T)  4)
#define OPERA_HBBTV_BWS_MSG_EXIT_BROWSER     ((OPERA_HBBTV_BWS_MSG_TYPE_T)  5)

/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/
/* Internal function declarations */
extern INT32 x_opera_hbbtv_init(VOID);

extern INT32 x_opera_hbbtv_reset(VOID);

extern INT32 x_opera_hbbtv_browser_is_alive(
    BOOL*               pb_is_alive);

extern INT32 x_opera_hbbtv_goto_url(
    const CHAR*                 s_uri );

extern INT32 x_opera_hbbtv_osd_update(
    GL_HSURFACE_T       h_surface,
    GL_RECT_T *         pt_rect );

/* External function declarations */
extern BOOL x_opera_hbbtv_support( VOID );

extern INT32 x_opera_hbbtv_start( VOID );

extern INT32 x_opera_hbbtv_stop( VOID );

extern INT32 x_opera_hbbtv_exit_process( VOID );

extern INT32 x_opera_hbbtv_create_app(
    BOOL                        b_brdcst_related,
    const CHAR*                 s_uri );

extern INT32 x_opera_hbbtv_init_osd(
    HANDLE_T            h_canvas_hbbtv);

extern INT32 x_opera_hbbtv_show( VOID );

extern INT32 x_opera_hbbtv_hide( VOID );

extern INT32 x_opera_hbbtv_wgl_set_focus( VOID );

extern INT32 x_opera_hbbtv_osd_reg_nfy(
    x_opera_hbbtv_osd_nfy_fct   pf_nfy,
    VOID*                       pv_tag );

extern INT32 x_opera_hbbtv_osd_show_reg_nfy(
    x_opera_hbbtv_osd_show_nfy_fct  pf_nfy,
    VOID*                           pv_tag );

extern INT32 x_opera_hbbtv_key_press(
    UINT32                      ui4_key_code,
    UINT32                      ui4_msg );

extern INT32 x_opera_hbbtv_set_country(
    ISO_3166_COUNT_T            s3166_country );

extern INT32 x_opera_hbbtv_set_gui_lang (
    ISO_639_LANG_T              s639_lang );

extern INT32 x_opera_hbbtv_set_audio_desc(
    BOOL                        b_ad_enabled );

extern INT32 x_opera_hbbtv_set_default_audio_lang(
    ISO_639_LANG_T              s639_lang );

extern INT32 x_opera_hbbtv_set_default_subtitle_lang(
    ISO_639_LANG_T                  s639_lang,
    OPERA_HBBTV_SUBTITLE_ENABLE_T   e_enable );

extern INT32 x_opera_hbbtv_set_default_subtitle_attr(
    OPERA_HBBTV_SUBTITLE_ATTR_T     e_attr );

extern INT32 x_opera_hbbtv_subtitle_get_prefer (
    HBBTV_STREAM_SUBTITLE_T *pSubtitle,
    size_t nmemb,
    size_t *ntotal);

extern INT32 x_opera_hbbtv_subtitle_set_prefer (
    HBBTV_STREAM_SUBTITLE_T *pSubtitle,
    size_t nmemb);

extern INT32 x_opera_hbbtv_subtitle_get_list (
    HBBTV_STREAM_SUBTITLE_T *pSubtitle,
    size_t nmemb,
    size_t *ntotal);

extern INT32 x_opera_hbbtv_subtitle_set_active (
    HBBTV_STREAM_SUBTITLE_T *pSubtitle,
    size_t nmemb);

extern INT32 x_opera_hbbtv_stm_get_audio_num(
    UINT16*                         pui2_num );

extern INT32 x_opera_hbbtv_stm_get_audio_lang(
    UINT16                          ui2_idx,
    ISO_639_LANG_T                  s639_lang );

extern INT32 x_opera_hbbtv_stm_get_audio(
    UINT16*                         pui2_idx );

extern INT32 x_opera_hbbtv_stm_set_audio(
    UINT16                          ui2_idx );

extern INT32 x_opera_hbbtv_set_next_audio(VOID);

extern INT32 x_opera_hbbtv_stm_set_visibility(
    BOOL                            b_visible );

extern INT32 x_opera_hbbtv_set_rating_age(
    UINT8                           ui8_rating_age );

extern INT32 x_opera_hbbtv_set_privacy(
    OPERA_HBBTV_PRIVACY_TYPE_T ui2_privacy_type,
    OPERA_HBBTV_PRIVACY_E privacy_cfg);

extern INT32 x_opera_hbbtv_device_id_cfg(OPERA_HBBTV_DEVICEID_CFG_E e_dev_id_cfg);

extern INT32 x_opera_hbbtv_set_drm_priority_array (
    OPERA_HBBTV_DRM_PRIO_ARR_T*     pt_drm_prio_arr );

extern INT32 x_opera_hbbtv_clear_cookie(VOID);

extern INT32 x_opera_hbbtv_browser_goto_url_reg_nfy(
    x_opera_hbbtv_layers_goto_url   pf_nfy,
    VOID*                           pv_tag );

extern INT32 x_opera_hbbtv_create_app_reg_nfy(
    x_opera_hbbtv_layers_create_app pf_nfy,
    VOID*                           pv_tag );

extern INT32 x_opera_hbbtv_input_keypress_reg_nfy(
    x_opera_hbbtv_layers_input_keypress pf_nfy,
    VOID*                               pv_tag );

extern INT32 x_opera_hbbtv_reg_browser_com_nfy(
        x_opera_hbbtv_browser_com_nfy_fct   pf_nfy_fct,
        VOID*                               pv_nfy_tag);

extern INT32 x_opera_hbbtv_release_res( VOID );

extern INT32 x_hbbtv_get_mode(
    UINT32*                     pui4_hbbtv_mode_mask );

extern INT32 x_hbbtv_set_mode(
    UINT32                      ui4_hbbtv_mode_mask );

extern INT32 x_hbbtv_get_mime_type_support(
    const CHAR*                 s_mime_type,
    BOOL*                       pb_supported );

extern INT32 x_hbbtv_set_app_svc_type(
    HBBTV_APP_SVC_TYPE_T              e_app_svc );

extern INT32 x_hbbtv_get_app_svc_type(
    HBBTV_APP_SVC_TYPE_T*             pe_app_svc );

extern INT32 x_hbbtv_stop_3rd_app(VOID);

extern INT32 x_hbbtv_launch_app(
    HBBTV_APP_INFO_T*               pt_hbbtv_app_info,
    x_hbbtv_app_event_nfy_fct       pf_launch_status_nfy,
    VOID*                           pv_tag );

extern INT32 x_hbbtv_kill_app(
    HBBTV_APP_KILL_INFO_T*          pt_app_kill_info);

extern INT32 x_hbbtv_launch_fvp_app(
    HBBTV_FVP_APP_LAUNCH_INFO_T*    pt_hbbtv_fvp_app_info);

extern BOOL x_hbbtv_is_fvp_preloaded(VOID);

extern VOID x_hbbtv_fvp_preload_reset(VOID);

extern INT32 x_hbbtv_get_app_type(
    HBBTV_APP_SRC_TYPE_T*           pe_app_type );

extern INT32 x_hbbtv_reg_app_event_listener(
        x_hbbtv_app_event_nfy_fct   pf_nfy_fct,
        VOID*                       pv_nfy_tag);

extern INT32 x_hbbtv_unreg_app_event_listener(
        x_hbbtv_app_event_nfy_fct   pf_nfy_fct,
        VOID*                       pv_nfy_tag);

extern INT32 x_hbbtv_app_status_nfy(
        INT32                       i4_msg_type,
        VOID*                       pv_data,
        SIZE_T                      z_data_len );
extern INT32 x_hbbtv_set_browser_status(
    HBBTV_BRWS_STATUS_E s);

extern INT32 x_hbbtv_fvp_reset(unsigned long long timesec);

extern INT32 x_hbbtv_get_hbbtv_state(
    OPERA_HBBTV_STATE_T*  pe_state);

#endif /* _X_OPERA_HBBTV_H_ */
